/*
 *   yukon admin angular app.js
 *   author: tzd-themes
 *
 * */

"use strict";
var peakApp = angular.module('peakApp', [ 'ui.router', 'ngAnimate', 'ui.load', 'ngSanitize', 'ngCookies', 'ui.bootstrap', 'ncy-angular-breadcrumb', 'ngRetina', 'NgSwitchery', 'angular-growl']);

/* Run Block */
peakApp.run(
    [ '$rootScope', '$state', '$location', '$cookieStore', '$stateParams',
        function ($rootScope, $state, $location, $cookieStore, $stateParams) {

            $rootScope.$state = $state;
            $rootScope.$stateParams = $stateParams;

            $rootScope.page_title = 'Peak Admin';
            
            // keep user logged in after page refresh
            //$rootScope.globals = $cookieStore.get('globals') || {};
            //if ($rootScope.globals.currentUser) {
            //    $http.defaults.headers.common['Authorization'] = 'Basic ' + $rootScope.globals.currentUser.authdata;
            //}

            $rootScope.$on('$stateChangeSuccess', function () {
                // scroll view to top
                $("html, body").animate({ scrollTop: 0 }, 200);
            });

            $rootScope.$on('$stateChangeStart', function () {
                // remove datatables fixedHeader from DOM
                if($(".FixedHeader_Cloned").length) {
                    $(".FixedHeader_Cloned").remove();
                }
                // remove daterangepicker element from DOM
                if($(".daterangepicker").length) {
                    $(".daterangepicker").remove();
                }
                // remove autosize element from DOM
                if($("#autosizejs").length) {
                    $("#autosizejs").remove();
                }
                
                // If we were previously not authenticated, then redirect to login
                var authenticated = $cookieStore.get('authenticated');
                var expiry = $cookieStore.get('authenticatedExpiry');
                if (typeof expiry === 'undefined') { expiry = 0; }
                var now = new Date();
                if (authenticated !== true || now.valueOf() > expiry) {
                    if (authenticated !== true) { console.log('peakApp.run - not authenticated, sending to /login') }
                    if (now.valueOf() > expiry) { console.log('peakApp.run - authentication expired, sending to /login') }
                    $location.path('/login');
                } else {
                    console.log('peakApp.run - authentication passed sending to '+$location.path() + " ("+((expiry-now.valueOf())/1000)+" seconds left until expiry)");
                }
            });
        }
    ]
);

peakApp
    /* Breadcrumbs options */
    .config(function($breadcrumbProvider) {
        $breadcrumbProvider.setOptions({
            prefixStateName: 'peak.home',
            templateUrl: 'views/partials/breadcrumbs.html'
        });
    })
    /* bootstrap-ui tooltips */
    .config(function($tooltipProvider ) {
        $tooltipProvider.options({
            appendToBody: true
        });
    })
    .config([
        'growlProvider',
        '$httpProvider',
        function (growlProvider, $httpProvider) {
            growlProvider.globalReversedOrder(true);
            growlProvider.globalDisableIcons(true);
            growlProvider.globalTimeToLive(5000);
            $httpProvider.interceptors.push(growlProvider.serverMessagesInterceptor);
        }
    ]);